"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMakeStyles = void 0;
require("./tools/Object.fromEntries");
const objectKeys_1 = require("./tools/objectKeys");
/** https://github.com/garronej/tss-react */
function createMakeStyles(params) {
    const { useTheme, css, cx } = params;
    function makeStyles() {
        return function (getCssObjects) {
            function useStyles(params) {
                const theme = useTheme();
                const cssObjects = typeof getCssObjects === "function"
                    ? getCssObjects(theme, params)
                    : getCssObjects;
                const classes = Object.fromEntries(objectKeys_1.objectKeys(cssObjects).map(key => [
                    key,
                    css(cssObjects[key]),
                ]));
                return {
                    classes,
                    theme,
                    css,
                    cx,
                };
            }
            //TODO: Return for composition as well.
            return { useStyles };
        };
    }
    return { makeStyles };
}
exports.createMakeStyles = createMakeStyles;
//# sourceMappingURL=createMakeStyles.js.map